########################################################################################################################################################################################  
########################################################################################################################################################################################
#!/usr/bin/python3						# IMPORTATION DE MODULES ET DÉFINITION DE FONCTIONS: NE PAS TOUCHER
# -*- coding: utf-8 -*-

from scipy.signal import *
import matplotlib.pyplot as plt
import scipy.io.wavfile as wavf
	
def enveloppe(data):
	m_hat = abs(hilbert(data)) #détection de l'enveloppe avec la fonction hilbert() puis normalisation
	m_hat=medfilt(m_hat,15)
	maxi=max(m_hat)				
	m=m_hat/maxi
	return m

def extraire_bits(signal_demodule):	
	j=0
	while(signal_demodule[j]==0):      # Suppression des 0 au début
		j=j+1
	signal_demodule=signal_demodule[j:]
	while(signal_demodule[-1]==0):	#suppression des 0 à la fin
		del signal_demodule[-1]
	for i in range(0,100):				#On rajoute des 0 jusqu'à un nombre supérieure à un multiple de 1000 (pb de division entière sinon il manque le dernier bit)
		signal_demodule.append(0)
		
	N=int(Tb*Fe) #nbr de points par bit
	signal_binaire=''
	for j in range(0,int(len(signal_demodule)/N)):   # Instant de décision a Tb/2 pour ne garder qu'un seul 1 ou 0 pour chaque bit
		signal_binaire+=str(signal_demodule[j*N+int(N/2)])
	return signal_binaire

 
###################################### PARTIE 1 ########################################################################################################################################


Fig,ax = plt.subplots(3,1)	#prépare une fenêtre qui pourra contenir trois graphiques superposés

Fe, data = wavf.read('export.wav') #chemin du fichier exporté: les données sont dans 'data'

Tb=1/44.1

print(Fe)
print(len(data))

ax[0].plot(data)

enveloppe=enveloppe(data)

ax[1].plot(enveloppe,'r')

################################### PARTIE 2 ##########################################################################"

moy=sum(enveloppe)/len(enveloppe)

i=0
signal_demodule=[]					# on crée une liste vide qu'on va remplir avec des 0 ou des 1 par comparaison à la moyenne
while(i<len(enveloppe)):			
	if enveloppe[i]>moy:
		signal_demodule.append(1)   #si la valeur > à la moy: on ajoute 1 à la liste demod
	else:
		signal_demodule.append(0)		# sinon on ajoute 0
	i=i+1
	
ax[2].plot(signal_demodule)

################################# PARTIE 3 ##########################################################################"


signal_binaire=extraire_bits(signal_demodule)

print(signal_binaire)
print(len(signal_binaire))
signal_binaire=signal_binaire[4:-2]
print(signal_binaire)

################################## PARTIE 4 ##########################################################################"


alphabet=" ABCDEFGHIJKLMNOPQRSTUVWXYZ'!,?."


message_traduit=''
i=0
while(i<len(signal_binaire)):          # Conversion des paquets de 5 bits en décimal: fonction int(...,2)
	index=int(signal_binaire[i:i+5], 2)
	message_traduit+=alphabet[index]  # et traduction du message avec l'alphabet
	i=i+5
	

print(message_traduit)		#affichage du message décodé



plt.show()





